/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Text/Wrap/Smart/XS.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#define PRE_PROCESS(text, string, t) do {        \
    char ch;                                     \
    subst_to_spaces (trim (text, &ch), &string); \
    *(char *)(text + strlen (text)) = ch;        \
    spaces_to_space (string);                    \
    t = string;                                  \
} while (0)

#define FINALIZE_STRING() do { \
    *dest = '\0';              \
    *string = buf;             \
    return;                    \
} while (0)

#define IS_WHITESPACE(ws) \
    (ws == ' ' || ws == '\f' || ws == '\n' || ws == '\r' || ws == '\t')

#define SAVE_STRING(str, size, t)        \
    Newx (str, size + 1, char);          \
                                         \
    strncpy (str, t, size);              \
    *(str + size) = '\0';                \
                                         \
    t += size;                           \
                                         \
    EXTEND (SP, 1);                      \
    PUSHs (sv_2mortal(newSVpv(str, 0))); \
                                         \
    Safefree (str);

static const char *
trim (const char *text, char *ch)
{
    char *p;

    p = (char *)text + strlen (text);
    while (p > text && IS_WHITESPACE (*(p - 1)))
      p--;
    *ch = *p;
    *p = '\0';

    p = (char *)text;
    while (IS_WHITESPACE (*p))
      p++;
    return p;
}

static void
subst_to_spaces (const char *text, char **string)
{
  if (strpbrk (text, "\f\n\r\t"))
    {
      const char *src = text;
      char *dest;
      char *buf, *ws;
      const char *eot = text + strlen (text);
      Newx (buf, strlen (text) + 1, char);
      dest = buf;
      while ((ws = strpbrk (src, "\f\n\r\t")))
        {
          char *p = ws;
          strncpy (dest, src, ws - src);
          dest += ws - src;
          src  += ws - src;
          switch (*ws)
            {
              case '\f': p++; break; /* Form Feed */
              case '\n': p++; break; /* LF */
              case '\r': p++; break; /* CR */
              case '\t': p++; break; /* Tab */
              default:     abort (); /* never reached */
            }
          if (*ws == '\r' && *p == '\n') /* CRLF */
            p++;
          src += p - ws;
          if (p < eot)
            *dest++ = ' ';
          else
            FINALIZE_STRING ();
        }
      if (src < eot)
        {
          strncpy (dest, src, eot - src);
          dest += eot - src;
          src  += eot - src;
        }
      FINALIZE_STRING ();
    }
  else
    *string = savepv (text);
}

static void
spaces_to_space (char *string)
{
    char *s, *p;
    s = p = string;

    while (*p)
      {
        while (*p == ' ' && *(p + 1) == ' ')
          p++;
        *s++ = *p++;
      }
    *s = '\0';
}

static unsigned long
calc_average (unsigned long length, unsigned int wrap_at)
{
    unsigned int i;
    i = length / wrap_at;
    if (length % wrap_at != 0)
      i++;
    return ceil ((double)length / (double)i);
}

#line 134 "lib/Text/Wrap/Smart/XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 278 "lib/Text/Wrap/Smart/XS.c"

XS_EUPXS(XS_Text__Wrap__Smart__XS_xs_exact_wrap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Wrap__Smart__XS_xs_exact_wrap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "text, wrap_at");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	text = (const char *)SvPV_nolen(ST(0))
;
	unsigned int	wrap_at = (unsigned int)SvUV(ST(1))
;
#line 132 "lib/Text/Wrap/Smart/XS.xs"
      unsigned long average, length, offset;
      char *string = NULL;
      char *eot, *t;
#line 297 "lib/Text/Wrap/Smart/XS.c"
#line 136 "lib/Text/Wrap/Smart/XS.xs"
      PRE_PROCESS (text, string, t);
      length = strlen (t);
      eot = t + length;

      if (length == 0)
        {
          Safefree (string);
          XSRETURN_EMPTY;
        }

      average = calc_average (length, wrap_at);

      for (offset = 0; offset < length && *t; offset += average)
        {
          char *str;
          const unsigned long size = average > (eot - t) ? (eot - t) : average;

          SAVE_STRING (str, size, t);
        }

      Safefree (string);
#line 320 "lib/Text/Wrap/Smart/XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Text__Wrap__Smart__XS_xs_fuzzy_wrap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Wrap__Smart__XS_xs_fuzzy_wrap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "text, wrap_at");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	text = (const char *)SvPV_nolen(ST(0))
;
	unsigned int	wrap_at = (unsigned int)SvUV(ST(1))
;
#line 164 "lib/Text/Wrap/Smart/XS.xs"
      unsigned long average, length;
      char *string = NULL;
      char *t;
#line 344 "lib/Text/Wrap/Smart/XS.c"
#line 168 "lib/Text/Wrap/Smart/XS.xs"
      PRE_PROCESS (text, string, t);
      length = strlen (t);

      if (length == 0)
        {
          Safefree (string);
          XSRETURN_EMPTY;
        }

      average = calc_average (length, wrap_at);

      while (*t)
        {
          unsigned int spaces = 0;
          long remaining = average;
          unsigned long size;
          char *str, *s;

          /* calculate pos and size of each chunk */
          for (s = t; *s;)
            {
              char *ptr = strchr (s, ' ');
              if (ptr)
                {
                  unsigned long next_space;
                  char *n, *p;
                  /* advance pos to space */
                  remaining -= ptr - s;
                  p = s = ptr;
                  /* skip space */
                  p++;
                  /* advance pos after space */
                  remaining -= p - s;
                  /* get distance to next space */
                  n = strchr (p, ' ');
                  next_space = n ? n - p : 0;
                  /* pos and size complete */
                  if (next_space > remaining && spaces >= 1)
                    break;
                  else if (remaining <= 0)
                    break;
                  spaces++;
                  s = p;
                }
              else
                s += strlen (s);
            }
          size = s - t;
          if (!size)
            break;

          SAVE_STRING (str, size, t);

          if (*t)
            t++;
        }

      Safefree (string);
#line 404 "lib/Text/Wrap/Smart/XS.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Text__Wrap__Smart__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__Wrap__Smart__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Text::Wrap::Smart::XS::xs_exact_wrap", XS_Text__Wrap__Smart__XS_xs_exact_wrap, file, "$$");
        (void)newXSproto_portable("Text::Wrap::Smart::XS::xs_fuzzy_wrap", XS_Text__Wrap__Smart__XS_xs_fuzzy_wrap, file, "$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
